%%%%%%% Data input %%%%%%%%%%%%%%%

resnum=[3963; 10230; 7892; 3947; 2096; 1255];
rtstart(:,1)=[1; 3; 8; 18; 28; 38; 48];
rtstart(:,2)=[2; 7; 17; 27; 37; 47; 50];
restimedata=zeros([],1);
for i=1:length(resnum)
    restimedata(length(restimedata)+1:length(restimedata)+resnum(i),1)=...
        rtstart(i,1)+(rtstart(i,2)-rtstart(i,1))*rand(resnum(i),1);
end
avgrestime=mean(restimedata);
stdrestime=std(restimedata);

inflate=207.342/113.6; %inflation adjustment from 1987 to 2007 dollars
presqftcost=linspace(85,165,18); %mean cost of 125
streetcost=[5000; 5000; 5000; 7000; 7000; 7000; 10000; 10000; 10000;...
    15000; 15000; 15000; 25000; 25000; 25000; 35000; 35000; 35000]; %1987 dollars
sewercost=[5000; 5000; 5000; 8000; 8000; 8000; 12000; 12000; 12000; 18000; ...
    18000; 18000; 5000; 5000; 5000; 5000; 5000; 5000];   %2007 dollars
stepsize=length(presqftcost)/(LTYPE*HTYPE);
stepcount=0;
sqftcost=zeros(LTYPE*HTYPE,1);
for hh=1:LTYPE*HTYPE
    sqftcost(hh,1)=mean(presqftcost(stepcount+1:stepcount+stepsize));
    strtcst(hh,1)=mean(streetcost(stepcount+1:stepcount+stepsize));
    swrcst(hh,1)=mean(sewercost(stepcount+1:stepcount+stepsize));
    stepcount=stepcount+stepsize;
end

infracost(1:LTYPE*HTYPE,1)=strtcst.*inflate+swrcst;
incomenum=round(116783.*[0.50 .35 0.15]);
inspan(:,1)=[40000; 80000; 120000];
inspan(:,2)=[69999; 119999; 200000];

incomedata=zeros([],1);
for i=1:length(incomenum)
    incomedata(length(incomedata)+1:length(incomedata)+incomenum(i),1)=...
        inspan(i,1)+(inspan(i,2)-inspan(i,1))*rand(incomenum(i),1);
end
parmhat=lognfit(log(incomedata));
avgincome=mean(incomedata);
stdincome=std(incomedata);

%%%%%%%%%% Farmers %%%%%%%%%%%%
% From USDA Census data for MD, PA, VA, DE
returnmeans=[201.17 150.17 51.82 570.94];
sizemans=[52 65 70 31];
AVGFARMRETURN=2486.3;
STDFARMRETURN=AVGFARMRETURN*0.10;